unit husogrid;

(*

THUSOGRID : Ver 1.0

Faruk DEMREL
Mu. (OB) Yzb.
K.K.Bil.Sis.D.Bil.Sis.Gel..
( 0312 ) 4115642

fdemirel@kkk.tsk.mil.tr

29.4.1999/ANKARA/TURKEY

1. GENERAL

	This Component has been written for Mr. Hseyin Bayk and alsd published with the permission of him.

2. UYARI

	This is fully free with source.  The Price is : -just a tip or code sample with e-mail:) -

3. THusoGrid COMPONENT

is derived from Tstringgrid  to perform;

 Export Data from a dataset to txt or vice-versa in a fixed width or delimited format


4. New METHODS

 Procedure SaveToFile(filename:string;seperator:string);

 Procedure LoadFromFile(filename:string;seperator:string);

 procedure FileToTable;
Text dosyadaki veriyi tabloya doldurur.

. procedure TableToFile;

5. New PROPERTIES

 property F_IMPFILENAME: string 
  full path and file name of the text file to be imported into the dataset

 property F_EXPFILENAME: string 
  full path and file name of the text file to be to filled with the content of a dataset

 property F_SOURCEDB: string 
  DB Alias for exp

 property F_SORCETABLE: string
  Exp Tablename

 property F_DESTDB: string 
  DB Alias for imp

 property F_DESTTABLE: string 
  imp Tablename

 property F_SEPERATOR: string 
  Seperator char for delimited ops

 property F_ISDELIMITED:boolean 
  as is

 property F_APPEND: boolean 
  as is. if false empties tye table before importing tye data

 property F_DEFCOLLEN:integer 
  col width for fixed width ops

 property F_AUTO:Boolean 
  if false, grid just shows the data. There is no write ops..

6. TEKRAR UYARI
  it is free and the risk is yours. Check the code, Test the code and then use.
  it is free for ditribution with my name and adres.
  
  i just want to earn some cool tips and code sample.


*)

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,  Grids, DBGrids,db, StdCtrls, DBCtrls, DBTables,Buttons,DsgnIntf;


Type
	TFileNameProperty = class(TStringProperty)
public
       	function GetAttributes: TPropertyAttributes;override;
        procedure Edit; override;
end;


Type
ThusoGrid = class(TStringGrid)
Private
  fsourceDB:string;
  fdestDB:string;
  fsourcetable:string;
  fdesttable:string;
  fseperator:string;
  fdelimited:boolean;
  fimpfilename:tfilename;
  fexpfilename:tfilename;
  fappend:boolean;
  fDefColLen:integer;
  FAUTO:BOOLEAN;
Protected
Public
Published
//methods
	Procedure savetofile(filename:string;seperator:string);
	Procedure loadfromfile(filename:string;seperator:string);

        procedure filetotable;
        procedure tabletofile;

        constructor create(aowner:tcomponent);override;

//props
        property F_IMPFILENAME: tfilename read fimpfilename write fimpfilename;
        property F_EXPFILENAME: tfilename read fexpfilename write fexpfilename;

        property F_SOURCEDB: string read fsourceDB write fsourceDB;
        property F_DESTDB: string read fdestDB write fdestDB;

        property F_SORCETABLE: string read fsourceTable write fsourceTable;
        property F_DESTTABLE: string read fDestTable write fDestTable;

        property F_SEPERATOR: string read fseperator write fseperator;
        property F_ISDELIMITED:boolean read fdelimited write fdelimited;

        property F_APPEND: boolean read fappend write fappend;
        property F_DEFCOLLEN:integer read fDefColLen write fDefColLen ;

        PROPERTY F_AUTO:BOOLEAN READ FAUTO WRITE FAUTO;
End;

Procedure Register;

Implementation
function TFileNameProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paDialog]
end {GetAttributes};

procedure TFileNameProperty.Edit;
begin
	with TOpenDialog.Create(Application) do
	try
		Title := GetName; 
		Filename := GetValue;
		Filter := 'All Files (*.*)|*.*';
		HelpContext := 0;
		Options := Options + [ofShowHelp, ofPathMustExist, 
			ofFileMustExist];
		if Execute then SetValue(Filename);
	finally
		Free
	end
end {Edit};

constructor thusogrid.create(aowner:tcomponent);
begin
  inherited;
  f_seperator:='&';
  f_defcollen:=10;
  
end;

procedure thusogrid.filetotable;
var
  tcol,trow:integer;
  tmptable:ttable;
  r,c:integer;
begin
   loadfromfile(F_impfilename,F_seperator[1]);
   if f_auto then
   begin
   tmptable:=ttable.create(self);
   tmptable.databasename:=F_destdb;
   tmptable.tablename:=F_desttable;
   tmptable.open;
   tcol:=tmptable.fieldcount;
   trow:=tmptable.recordcount;
   if tcol=colcount then
   begin
       if not F_append then begin
       tmptable.close;
       tmptable.emptytable; //append modunda
       tmptable.open;       //deilse tabloyu boalt
       end;
       for r:=0 to rowcount-1 do
       begin
            tmptable.append;
            for c:=0 to colcount-1 do
            begin
              tmptable.fields[c].text:=cells[c,r];
            end;
       end;
       tmptable.post;
       tmptable.close;
   end
   else
   begin //tabloya aktarma yapma
      showmessage(inttostr(tcol)+' kolon saylar eit deil '+inttostr(colcount));
   end;
   tmptable.close;
   tmptable.free;
 end;
end;

procedure ThusoGrid.tabletofile;
var
  r,c:integer;
  tmptable:ttable;
begin
   tmptable:=ttable.create(self);
   tmptable.databasename:=F_SOURCEdb;
   tmptable.tablename:=F_SORCETABLE;
   tmptable.open;
   colcount:=tmptable.fieldcount;
   rowcount:=tmptable.recordcount;
   for r:=0 to rowcount-1 do
   begin
   for c:=0 to colcount-1 do
   cells[c,r]:=tmptable.fields[c].text;
   tmptable.next;
   end;

   if f_auto then
   savetofile(F_ExpFileName,F_seperator);

   tmptable.close;
   tmptable.free;

end;

Procedure ThusoGrid.savetofile(filename:string; seperator:string);
function fixit(s:string;l:integer):string;
begin
   while length(s)<l do
   s:=s+' ';
   result:=copy(s,1,l);
end;
var f:system.text;
r, c:integer;
satir:string;
Begin

	if filename<>'' then// Dosya adnn belirtildiinden emin olmalyz.
	assignfile (f, filename)
	else showmessage('Dosya adn belirtmelisiniz...');
	rewrite(f);
	for r:=0 to rowcount-1 do
	Begin
		satir:='';
		for c:=0 to colcount-1 do

                if F_isdelimited then
		satir:=satir+cells[c, r]+seperator
                else
                satir:=satir+fixit(cells[c, r],F_DefColLen);

		writeln(f, satir);
	End;
	showmessage('Dosya Kaydedildi');
	closefile(f);
End;

Procedure ThusoGrid.loadfromfile(filename: string;seperator:string);
var f:system.text;
r, c:integer;
satir:string;
Begin
	if filename<>'' then
	assignfile (f, filename)
	else showmessage('Dosya adn belirtmelisiniz...');
	if fileexists(filename) then
	Begin
		reset(f);
		r:=0;
		c:=0;
		while not eof(f) do
		Begin
			readln(f, satir);

                        if f_isdelimited then
                        begin
			   while pos(seperator, satir)>0 do
                           Begin
				cells[c, r]:= copy(satir, 0, pos
				(seperator, satir)-1);
				satir:=copy(satir, pos
				(seperator, satir)+
				length(seperator), length(satir));
				inc(c, 1);
                                if colcount<c then colcount:=c+1;
			   End; //while
                        	cells[c, r]:= satir;
                        end //if isdelimite
                        else
                        begin //fix length
                          while length(satir)>F_DEFCOLLEN do
                          begin
				cells[c, r]:= copy(satir, 0, f_defcollen);
                                satir:=copy(satir, f_defcollen,length(satir));
                              	inc(c, 1);
                                if colcount<c then colcount:=c+1;
                          end; //while
                             cells[c, r]:= satir;
                        end; //isdelimited else
			inc(r, 1);
                        rowcount:=r;
			c:=0;
			satir:='';
		End;//while  nor eof

		closefile(f);
                rowcount:=r;
	End
	else showmessage('Dosya Bulunamad');
End;//proc

Procedure Register;
Begin
	RegisterComponents('Faruk',[ThusoGrid]);
        RegisterPropertyEditor(TypeInfo(TFileName),nil,'',TFileNameProperty)End;
End.

